--
-- G6util.vhd
--
-- package for various stuff like parity generation in simulation
-- Copyright 1998 Jun Makino 
library ieee,std;
use std.textio.all;
use ieee.std_logic_1164.all;

package g6util_sim is

    function generate_parity(din: std_logic_vector)
        return std_logic_vector;

end g6util_sim;

package body g6util_sim is
    
    function generate_parity(din: std_logic_vector)
        return std_logic_vector is
        variable i,j,l,m : integer;
        variable p : std_logic;
        variable retval: std_logic_vector((din'left/8) downto 0 );
    begin
        j := din'left  /8;
        for l in 0 to j loop
            p := '0';
            for i in 0 to 7 loop
                p := p xor din(l*8+i);
            end loop;
            retval(l) := p;
        end loop;
        return retval(j downto 0);
    end generate_parity;

end g6util_sim;

