-- ijp_state.vhd
-- 
--
-- Version 0.0 1999/9/13 J. Makino


LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;


ENTITY ijp_state IS
    PORT(
        CLK		: IN	STD_LOGIC;
        ijp_in		: IN	STD_LOGIC;
        ijp_out            : out   std_logic
	);
END ijp_state;

ARCHITECTURE a OF ijp_state IS

    signal ijp_internal : std_logic;
    signal sreg0 : std_logic;
    signal sreg1 : std_logic;
    signal sreg2 : std_logic;


BEGIN
    ijp_out <= ijp_internal;
    process(clk)
    begin
        if(clk'event and clk='1') then
            sreg0 <= ijp_in;
            sreg1 <= sreg0;
            sreg2 <= sreg1;
            if (sreg0 = '1' and sreg1 = '1' and sreg2 = '1' ) then
                ijp_internal <= '1';
            elsif (sreg0 = '0' and sreg1 = '0' and sreg2 = '0' ) then
                ijp_internal <= '0';
            end if;
        end if;
    end process;

END a;











