-- linktest
-- top test driver for fo outlink & jp/ip inlink
--
-- Version 0.0 1999/8/27J. Makino
-- MAKUTIL ADD_PARITY 36



LIBRARY ieee;
USE ieee.std_logic_1164.all;
-- USE ieee.std_logic_unsigned.all;

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;


ENTITY linktest IS

	PORT
	(
		CLK		: IN	STD_LOGIC;
		CLK2		: IN	STD_LOGIC;
		din		: IN	std_logic_vector(35 downto 0);
		dsin		: IN 	std_logic;
                rstin         : IN    std_logic;
                auxin             : IN    std_logic_vector(1 downto 0);
                enable          : in    std_logic;
		rst		: IN	STD_LOGIC;
                ef              : in    std_logic;
		DOUT		: OUT 	std_logic_vector(35 downto 0);
		dsout		: OUT 	std_logic;
                rstout          : out    std_logic;
                auxout             : out    std_logic_vector(1 downto 0);
                re              : out std_logic
	);
	
END linktest;


ARCHITECTURE a OF linktest IS

    component jpfpga
	PORT
	(
		rst		: IN	STD_LOGIC;
		CLK		: IN	STD_LOGIC;
		CLK2		: IN	STD_LOGIC;
                enable          : in    std_logic;
		din		: IN	std_logic_vector(20 downto 0);
                ef              : in    std_logic;
		DOUT		: OUT 	std_logic_vector(35 downto 0);
		dsout		: OUT 	std_logic;
                rstout          : out    std_logic;
                auxout             : out    std_logic_vector(1 downto 0);
                re              : out std_logic
	);
    end component;
    component foconvert
	PORT(
		CLK		: IN	STD_LOGIC;
		CLK2		: IN	STD_LOGIC;
		din		: IN	std_logic_vector(35 downto 0);
		dsin		: IN 	std_logic;
                rstin         : IN    std_logic;
                auxin             : IN    std_logic_vector(1 downto 0);
		dout		: OUT 	std_logic_vector(20 downto 0)
	);
    end component;
    signal data : std_logic_vector (20 downto 0);

BEGIN
    u_foconvert: foconvert port map(
        CLK=>CLK,
        CLK2=>CLK2,
        din=>din,
        dsin=>dsin,
        rstin=>rstin,
        auxin=>auxin,
        dout=>data);

    u_jpfpga: jpfpga port map(
        rst=>rst,
        CLK=>CLK,
        CLK2=>CLK2,
        enable=>enable,
        din=>data,
        ef=>ef,
        DOUT=>DOUT,
        dsout=>dsout,
        rstout=>rstout,
        auxout=>auxout,
        re=>re);
    
END a;











