-- speedmeter.vhd
-- SPEEDMETER for GRAPE-6 processor board
--
-- Version 0.0 1999/9/13 J. Makino


LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;


ENTITY speedmeter IS
    PORT(
        rst		: IN	STD_LOGIC;
        CLK		: IN	STD_LOGIC;
        calcsts		: IN	STD_LOGIC;
        speedval	: out	std_logic_vector(11 downto 0)
	);
END speedmeter;

ARCHITECTURE a OF speedmeter IS


    signal base_counter : std_logic_vector(20 downto 0);
    signal activity_counter : std_logic_vector(20 downto 0);
    signal activity_register : std_logic_vector(3 downto 0);

BEGIN

-- input data registers 
    process(clk)
    begin
        if(clk'event and clk='1') then
            if ((rst = '0') or (base_counter(20 downto 17) = 13)) then
                base_counter <= "000000000000000000000";
                activity_register <= activity_counter(20 downto 17);
                activity_counter <= "000000000000000000000";
            else
                base_counter <= base_counter + 1;
                if (calcsts = '0') then
                    activity_counter <= activity_counter + 1;
                end if;
            end if;
        end if;
    end process;
    speedval <= "000000000000" when activity_register = 0
                else "000000000001" when activity_register = 1
                else "000000000011" when activity_register = 2
                else "000000000111" when activity_register = 3
                else "000000001111" when activity_register = 4
                else "000000011111" when activity_register = 5
                else "000000111111" when activity_register = 6
                else "000001111111" when activity_register = 7
                else "000011111111" when activity_register = 8
                else "000111111111" when activity_register = 9
                else "001111111111" when activity_register = 10
                else "011111111111" when activity_register = 11
                else "111111111111" ;
END a;
