-- utilfpga2
-- change name from utilfpga on 2000/6/19
-- utilfpga
-- top level for util fpga which performs various functions
--
-- Version 0.0 1999/9/18 J. Makino
-- Version 1.1 2000/1/25 J. Makino
-- PLL mode etc "correct" setting 
-- Version 1.1a 2000/2/13 J. Makino
-- B1PLL mode changed from 01Z to ZZZ

-- Version 1.1b 2000/2/18 J. Makino
-- change b0pllmode? Not yet changed ...

-- Version 1.2 2000/6/19 J. Makino
-- Name change ...

-- JPPLL
--0: 1F0
--1: 1F1
--2: 3F0
--3: 3F1
--4: 4F0
--5: 4F1
--6: FS

--1Q:  normal phase  2X clock -> 0, 1  should be MID MID (ZZ)
--3Q:  normal phase  1X clock ->  2, 3 should be 0 0 
--4Q: inverted phase 2X clock (FB) 4, 5  should be 1 1
--FS: 1

--i.e.,  dindum =0 -> 11100ZZ

--IPPLL should be the same as JPPLL


--B0 PLL  Xtal-> CLK, BCLK

-- 4Q->CKBUF9/3 founit, lvcbuf etc
-- 3Q->CKBUF4/1 g6modu clock only
-- 2Q->PLL1(REF)
-- 1Q->CKBUF2,FB
--0: 2F0
--1: 2F1
--2: 3F0
--3: 3F1
--4: 4F0
--5: 4F1
--6: FS

--FS  LOW, all others ALL MID?  0ZZZZZZ 

-- B1 PLL generates PCLKA/B,(sysclk) and MCLOCK (clock for buffers on board)
-- Not clear what should be done
-- reference comes from pll0-2q
-- FB <- 3q
-- used clocks: 1q only  ckbuf5/6 ->sysclk
--0: 2F0
--1: 2F1
--2: 3F0
--3: 3F1
--4: FS

--G6PLLMODE

--0: FS0
--1: FS1
--2: MN0
--3: MN1

--

--MN0 MN1       Fout/Fin
--0   0            1
--1   0            2
--0   1            4
--1   1            8

--FS0 FS1       FVCO/FOUT
--0   0            1
--1   0            2
--0   1            4
--1   1           32

-- 991 mode select table
-- F1 F0      1Q,2Q        3Q       4Q
-- L L         -4         Div2     Div2
-- L M         -3          -6       -6
-- L H         -2          -4       -4
-- M L         -1          -2       -2
-- M M          0           0        0
-- M H          1           2        2
-- H L          2           4        4
-- H M          2           4        4
-- H H          4         Div4     invert
--
-- FS     fNOM     tunit
-- L      15-30     44
-- M      25-50     26
-- H      40-80     16

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;


ENTITY utilfpga2 IS
    
    PORT
	(
            rst		: IN	STD_LOGIC;
            CLK		: IN	STD_LOGIC;
            we		: IN	STD_LOGIC;
            din		: IN	std_logic_vector(15 downto 0);
            calcsts		: IN	STD_LOGIC;
            ledout	: out	std_logic_vector(11 downto 0);
            dindum      : in    std_logic;
            sel_con     : out   std_logic;
            jppllmode   : out   std_logic_vector(6 downto 0);
            ippllmode   : out   std_logic_vector(6 downto 0);
            b0pllmode   : out   std_logic_vector(6 downto 0);
            b1pllmode   : out   std_logic_vector(4 downto 0);
            g6pllmode   : out   std_logic_vector(3 downto 0)
	);
	
END utilfpga2;


ARCHITECTURE a OF utilfpga2 IS

component led_write
    PORT(
        rst		: IN	STD_LOGIC;
        CLK		: IN	STD_LOGIC;
        we		: IN	STD_LOGIC;
        din		: IN	std_logic_vector(15 downto 0);
        dout            : out   std_logic_vector(11 downto 0);
        mode            : out std_logic
	);
END component;

component speedmeter
    PORT(
        rst		: IN	STD_LOGIC;
        CLK		: IN	STD_LOGIC;
        calcsts		: IN	STD_LOGIC;
        speedval	: out	std_logic_vector(11 downto 0)
	);
end component;

    signal led1 : std_logic_vector(11 downto 0);
    signal led2 : std_logic_vector(11 downto 0);
    signal mode : std_logic;
BEGIN
    
    u_speedmeter: speedmeter port map(       
        rst=>rst,
        CLK=>CLK,
        calcsts=>calcsts,
        speedval=>led1);
    u_ledwrite: led_write port map(
        rst=>rst,
        CLK=>CLK,
        we=>we,
        din=>din,
        dout=>led2,
        mode=>mode);

    ledout <= led1 when mode = '0' else led2;

    jppllmode <= "11100ZZ" when dindum = '0' else "1111111";
    ippllmode <= "11100ZZ" when dindum = '0' else "1111111";
    g6pllmode <= "0100" when dindum = '0' else "1111";
    sel_con <= '1';
    b0pllmode <= "ZZZ0100" when dindum = '0' else "1111111";
--    b1pllmode <= "0ZZZZ" when dindum = '0' else "11111";
-- Changed on 2000/11/30 - Fairchild module?
   b1pllmode <= "ZZZ0Z" when dindum = '0' else "11111";
--  The following is OK for version 3 module with Toshiba 16374s 
--    b1pllmode <= "ZZZ0Z" when dindum = '0' else "11111";
--  Test for TI 16374
--  The following pair seems to be most stable ...... (2001/5/20)
--    b0pllmode <= "ZZZ0100" when dindum = '0' else "1111111";
--    b1pllmode <= "ZZZZZ" when dindum = '0' else "11111";
--    b0pllmode <= "ZZZ0Z00" when dindum = '0' else "1111111";
--    b1pllmode <= "ZZ1ZZ" when dindum = '0' else "11111";
END a;
